<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for artDerMeldungType StructType
 * @subpackage Structs
 */
class ArtDerMeldungType extends AbstractStructBase
{
    /**
     * The erstmeldung
     * Meta information extracted from the WSDL
     * - choice: erstmeldung | berichtigung
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \StructType\EmptyElementType
     */
    public $erstmeldung;
    /**
     * The berichtigung
     * Meta information extracted from the WSDL
     * - choice: erstmeldung | berichtigung
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \StructType\BerichtigungType
     */
    public $berichtigung;
    /**
     * Constructor method for artDerMeldungType
     * @uses ArtDerMeldungType::setErstmeldung()
     * @uses ArtDerMeldungType::setBerichtigung()
     * @param \StructType\EmptyElementType $erstmeldung
     * @param \StructType\BerichtigungType $berichtigung
     */
    public function __construct(\StructType\EmptyElementType $erstmeldung = null, \StructType\BerichtigungType $berichtigung = null)
    {
        $this
            ->setErstmeldung($erstmeldung)
            ->setBerichtigung($berichtigung);
    }
    /**
     * Get erstmeldung value
     * @return \StructType\EmptyElementType|null
     */
    public function getErstmeldung()
    {
        return isset($this->erstmeldung) ? $this->erstmeldung : null;
    }
    /**
     * This method is responsible for validating the value passed to the setErstmeldung method
     * This method is willingly generated in order to preserve the one-line inline validation within the setErstmeldung method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateErstmeldungForChoiceConstraintsFromSetErstmeldung($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'berichtigung',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property erstmeldung can\'t be set as the property %s is already set. Only one property must be set among these properties: erstmeldung, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set erstmeldung value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EmptyElementType $erstmeldung
     * @return \StructType\ArtDerMeldungType
     */
    public function setErstmeldung(\StructType\EmptyElementType $erstmeldung = null)
    {
        // validation for constraint: choice(erstmeldung, berichtigung)
        if ('' !== ($erstmeldungChoiceErrorMessage = self::validateErstmeldungForChoiceConstraintsFromSetErstmeldung($erstmeldung))) {
            throw new \InvalidArgumentException($erstmeldungChoiceErrorMessage, __LINE__);
        }
        if (is_null($erstmeldung) || (is_array($erstmeldung) && empty($erstmeldung))) {
            unset($this->erstmeldung);
        } else {
            $this->erstmeldung = $erstmeldung;
        }
        return $this;
    }
    /**
     * Get berichtigung value
     * @return \StructType\BerichtigungType|null
     */
    public function getBerichtigung()
    {
        return isset($this->berichtigung) ? $this->berichtigung : null;
    }
    /**
     * This method is responsible for validating the value passed to the setBerichtigung method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBerichtigung method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateBerichtigungForChoiceConstraintsFromSetBerichtigung($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'erstmeldung',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property berichtigung can\'t be set as the property %s is already set. Only one property must be set among these properties: berichtigung, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set berichtigung value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\BerichtigungType $berichtigung
     * @return \StructType\ArtDerMeldungType
     */
    public function setBerichtigung(\StructType\BerichtigungType $berichtigung = null)
    {
        // validation for constraint: choice(erstmeldung, berichtigung)
        if ('' !== ($berichtigungChoiceErrorMessage = self::validateBerichtigungForChoiceConstraintsFromSetBerichtigung($berichtigung))) {
            throw new \InvalidArgumentException($berichtigungChoiceErrorMessage, __LINE__);
        }
        if (is_null($berichtigung) || (is_array($berichtigung) && empty($berichtigung))) {
            unset($this->berichtigung);
        } else {
            $this->berichtigung = $berichtigung;
        }
        return $this;
    }
}
