<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ddMeldungType StructType
 * @subpackage Structs
 */
class DdMeldungType extends AbstractStructBase
{
    /**
     * The person
     * @var \StructType\PersonType
     */
    public $person;
    /**
     * The grundDerMeldung
     * @var \StructType\GrundDerMeldungType
     */
    public $grundDerMeldung;
    /**
     * The emittent
     * @var \StructType\EmittentType
     */
    public $emittent;
    /**
     * The geschaeft
     * @var \StructType\GeschaeftType
     */
    public $geschaeft;
    /**
     * Constructor method for ddMeldungType
     * @uses DdMeldungType::setPerson()
     * @uses DdMeldungType::setGrundDerMeldung()
     * @uses DdMeldungType::setEmittent()
     * @uses DdMeldungType::setGeschaeft()
     * @param \StructType\PersonType $person
     * @param \StructType\GrundDerMeldungType $grundDerMeldung
     * @param \StructType\EmittentType $emittent
     * @param \StructType\GeschaeftType $geschaeft
     */
    public function __construct(\StructType\PersonType $person = null, \StructType\GrundDerMeldungType $grundDerMeldung = null, \StructType\EmittentType $emittent = null, \StructType\GeschaeftType $geschaeft = null)
    {
        $this
            ->setPerson($person)
            ->setGrundDerMeldung($grundDerMeldung)
            ->setEmittent($emittent)
            ->setGeschaeft($geschaeft);
    }
    /**
     * Get person value
     * @return \StructType\PersonType|null
     */
    public function getPerson()
    {
        return $this->person;
    }
    /**
     * Set person value
     * @param \StructType\PersonType $person
     * @return \StructType\DdMeldungType
     */
    public function setPerson(\StructType\PersonType $person = null)
    {
        $this->person = $person;
        return $this;
    }
    /**
     * Get grundDerMeldung value
     * @return \StructType\GrundDerMeldungType|null
     */
    public function getGrundDerMeldung()
    {
        return $this->grundDerMeldung;
    }
    /**
     * Set grundDerMeldung value
     * @param \StructType\GrundDerMeldungType $grundDerMeldung
     * @return \StructType\DdMeldungType
     */
    public function setGrundDerMeldung(\StructType\GrundDerMeldungType $grundDerMeldung = null)
    {
        $this->grundDerMeldung = $grundDerMeldung;
        return $this;
    }
    /**
     * Get emittent value
     * @return \StructType\EmittentType|null
     */
    public function getEmittent()
    {
        return $this->emittent;
    }
    /**
     * Set emittent value
     * @param \StructType\EmittentType $emittent
     * @return \StructType\DdMeldungType
     */
    public function setEmittent(\StructType\EmittentType $emittent = null)
    {
        $this->emittent = $emittent;
        return $this;
    }
    /**
     * Get geschaeft value
     * @return \StructType\GeschaeftType|null
     */
    public function getGeschaeft()
    {
        return $this->geschaeft;
    }
    /**
     * Set geschaeft value
     * @param \StructType\GeschaeftType $geschaeft
     * @return \StructType\DdMeldungType
     */
    public function setGeschaeft(\StructType\GeschaeftType $geschaeft = null)
    {
        $this->geschaeft = $geschaeft;
        return $this;
    }
}
