<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ortDesGeschaeftsType StructType
 * @subpackage Structs
 */
class OrtDesGeschaeftsType extends AbstractStructBase
{
    /**
     * The handelsplatz
     * Meta information extracted from the WSDL
     * - choice: handelsplatz | ausserhalbEinesHandelsplatzes
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \StructType\HandelsplatzType
     */
    public $handelsplatz;
    /**
     * The ausserhalbEinesHandelsplatzes
     * Meta information extracted from the WSDL
     * - choice: handelsplatz | ausserhalbEinesHandelsplatzes
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \StructType\EmptyElementType
     */
    public $ausserhalbEinesHandelsplatzes;
    /**
     * Constructor method for ortDesGeschaeftsType
     * @uses OrtDesGeschaeftsType::setHandelsplatz()
     * @uses OrtDesGeschaeftsType::setAusserhalbEinesHandelsplatzes()
     * @param \StructType\HandelsplatzType $handelsplatz
     * @param \StructType\EmptyElementType $ausserhalbEinesHandelsplatzes
     */
    public function __construct(\StructType\HandelsplatzType $handelsplatz = null, \StructType\EmptyElementType $ausserhalbEinesHandelsplatzes = null)
    {
        $this
            ->setHandelsplatz($handelsplatz)
            ->setAusserhalbEinesHandelsplatzes($ausserhalbEinesHandelsplatzes);
    }
    /**
     * Get handelsplatz value
     * @return \StructType\HandelsplatzType|null
     */
    public function getHandelsplatz()
    {
        return isset($this->handelsplatz) ? $this->handelsplatz : null;
    }
    /**
     * This method is responsible for validating the value passed to the setHandelsplatz method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHandelsplatz method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateHandelsplatzForChoiceConstraintsFromSetHandelsplatz($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'ausserhalbEinesHandelsplatzes',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property handelsplatz can\'t be set as the property %s is already set. Only one property must be set among these properties: handelsplatz, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set handelsplatz value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\HandelsplatzType $handelsplatz
     * @return \StructType\OrtDesGeschaeftsType
     */
    public function setHandelsplatz(\StructType\HandelsplatzType $handelsplatz = null)
    {
        // validation for constraint: choice(handelsplatz, ausserhalbEinesHandelsplatzes)
        if ('' !== ($handelsplatzChoiceErrorMessage = self::validateHandelsplatzForChoiceConstraintsFromSetHandelsplatz($handelsplatz))) {
            throw new \InvalidArgumentException($handelsplatzChoiceErrorMessage, __LINE__);
        }
        if (is_null($handelsplatz) || (is_array($handelsplatz) && empty($handelsplatz))) {
            unset($this->handelsplatz);
        } else {
            $this->handelsplatz = $handelsplatz;
        }
        return $this;
    }
    /**
     * Get ausserhalbEinesHandelsplatzes value
     * @return \StructType\EmptyElementType|null
     */
    public function getAusserhalbEinesHandelsplatzes()
    {
        return isset($this->ausserhalbEinesHandelsplatzes) ? $this->ausserhalbEinesHandelsplatzes : null;
    }
    /**
     * This method is responsible for validating the value passed to the setAusserhalbEinesHandelsplatzes method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAusserhalbEinesHandelsplatzes method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateAusserhalbEinesHandelsplatzesForChoiceConstraintsFromSetAusserhalbEinesHandelsplatzes($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'handelsplatz',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property ausserhalbEinesHandelsplatzes can\'t be set as the property %s is already set. Only one property must be set among these properties: ausserhalbEinesHandelsplatzes, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set ausserhalbEinesHandelsplatzes value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EmptyElementType $ausserhalbEinesHandelsplatzes
     * @return \StructType\OrtDesGeschaeftsType
     */
    public function setAusserhalbEinesHandelsplatzes(\StructType\EmptyElementType $ausserhalbEinesHandelsplatzes = null)
    {
        // validation for constraint: choice(handelsplatz, ausserhalbEinesHandelsplatzes)
        if ('' !== ($ausserhalbEinesHandelsplatzesChoiceErrorMessage = self::validateAusserhalbEinesHandelsplatzesForChoiceConstraintsFromSetAusserhalbEinesHandelsplatzes($ausserhalbEinesHandelsplatzes))) {
            throw new \InvalidArgumentException($ausserhalbEinesHandelsplatzesChoiceErrorMessage, __LINE__);
        }
        if (is_null($ausserhalbEinesHandelsplatzes) || (is_array($ausserhalbEinesHandelsplatzes) && empty($ausserhalbEinesHandelsplatzes))) {
            unset($this->ausserhalbEinesHandelsplatzes);
        } else {
            $this->ausserhalbEinesHandelsplatzes = $ausserhalbEinesHandelsplatzes;
        }
        return $this;
    }
}
