<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for positionType StructType
 * @subpackage Structs
 */
class PositionType extends AbstractStructBase
{
    /**
     * The vorstand
     * Meta information extracted from the WSDL
     * - choice: vorstand | aufsichtsrat | sonstigeFuehrungsperson | inEngerBeziehung
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \StructType\EmptyElementType
     */
    public $vorstand;
    /**
     * The aufsichtsrat
     * Meta information extracted from the WSDL
     * - choice: vorstand | aufsichtsrat | sonstigeFuehrungsperson | inEngerBeziehung
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \StructType\EmptyElementType
     */
    public $aufsichtsrat;
    /**
     * The sonstigeFuehrungsperson
     * Meta information extracted from the WSDL
     * - choice: vorstand | aufsichtsrat | sonstigeFuehrungsperson | inEngerBeziehung
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \StructType\PositionSonstigeFuehrungspersonType
     */
    public $sonstigeFuehrungsperson;
    /**
     * The inEngerBeziehung
     * Meta information extracted from the WSDL
     * - choice: vorstand | aufsichtsrat | sonstigeFuehrungsperson | inEngerBeziehung
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \StructType\PositionInEngerBeziehungType
     */
    public $inEngerBeziehung;
    /**
     * Constructor method for positionType
     * @uses PositionType::setVorstand()
     * @uses PositionType::setAufsichtsrat()
     * @uses PositionType::setSonstigeFuehrungsperson()
     * @uses PositionType::setInEngerBeziehung()
     * @param \StructType\EmptyElementType $vorstand
     * @param \StructType\EmptyElementType $aufsichtsrat
     * @param \StructType\PositionSonstigeFuehrungspersonType $sonstigeFuehrungsperson
     * @param \StructType\PositionInEngerBeziehungType $inEngerBeziehung
     */
    public function __construct(\StructType\EmptyElementType $vorstand = null, \StructType\EmptyElementType $aufsichtsrat = null, \StructType\PositionSonstigeFuehrungspersonType $sonstigeFuehrungsperson = null, \StructType\PositionInEngerBeziehungType $inEngerBeziehung = null)
    {
        $this
            ->setVorstand($vorstand)
            ->setAufsichtsrat($aufsichtsrat)
            ->setSonstigeFuehrungsperson($sonstigeFuehrungsperson)
            ->setInEngerBeziehung($inEngerBeziehung);
    }
    /**
     * Get vorstand value
     * @return \StructType\EmptyElementType|null
     */
    public function getVorstand()
    {
        return isset($this->vorstand) ? $this->vorstand : null;
    }
    /**
     * This method is responsible for validating the value passed to the setVorstand method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVorstand method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateVorstandForChoiceConstraintsFromSetVorstand($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'aufsichtsrat',
            'sonstigeFuehrungsperson',
            'inEngerBeziehung',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property vorstand can\'t be set as the property %s is already set. Only one property must be set among these properties: vorstand, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set vorstand value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EmptyElementType $vorstand
     * @return \StructType\PositionType
     */
    public function setVorstand(\StructType\EmptyElementType $vorstand = null)
    {
        // validation for constraint: choice(vorstand, aufsichtsrat, sonstigeFuehrungsperson, inEngerBeziehung)
        if ('' !== ($vorstandChoiceErrorMessage = self::validateVorstandForChoiceConstraintsFromSetVorstand($vorstand))) {
            throw new \InvalidArgumentException($vorstandChoiceErrorMessage, __LINE__);
        }
        if (is_null($vorstand) || (is_array($vorstand) && empty($vorstand))) {
            unset($this->vorstand);
        } else {
            $this->vorstand = $vorstand;
        }
        return $this;
    }
    /**
     * Get aufsichtsrat value
     * @return \StructType\EmptyElementType|null
     */
    public function getAufsichtsrat()
    {
        return isset($this->aufsichtsrat) ? $this->aufsichtsrat : null;
    }
    /**
     * This method is responsible for validating the value passed to the setAufsichtsrat method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAufsichtsrat method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateAufsichtsratForChoiceConstraintsFromSetAufsichtsrat($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'vorstand',
            'sonstigeFuehrungsperson',
            'inEngerBeziehung',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property aufsichtsrat can\'t be set as the property %s is already set. Only one property must be set among these properties: aufsichtsrat, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set aufsichtsrat value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EmptyElementType $aufsichtsrat
     * @return \StructType\PositionType
     */
    public function setAufsichtsrat(\StructType\EmptyElementType $aufsichtsrat = null)
    {
        // validation for constraint: choice(vorstand, aufsichtsrat, sonstigeFuehrungsperson, inEngerBeziehung)
        if ('' !== ($aufsichtsratChoiceErrorMessage = self::validateAufsichtsratForChoiceConstraintsFromSetAufsichtsrat($aufsichtsrat))) {
            throw new \InvalidArgumentException($aufsichtsratChoiceErrorMessage, __LINE__);
        }
        if (is_null($aufsichtsrat) || (is_array($aufsichtsrat) && empty($aufsichtsrat))) {
            unset($this->aufsichtsrat);
        } else {
            $this->aufsichtsrat = $aufsichtsrat;
        }
        return $this;
    }
    /**
     * Get sonstigeFuehrungsperson value
     * @return \StructType\PositionSonstigeFuehrungspersonType|null
     */
    public function getSonstigeFuehrungsperson()
    {
        return isset($this->sonstigeFuehrungsperson) ? $this->sonstigeFuehrungsperson : null;
    }
    /**
     * This method is responsible for validating the value passed to the setSonstigeFuehrungsperson method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSonstigeFuehrungsperson method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateSonstigeFuehrungspersonForChoiceConstraintsFromSetSonstigeFuehrungsperson($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'vorstand',
            'aufsichtsrat',
            'inEngerBeziehung',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property sonstigeFuehrungsperson can\'t be set as the property %s is already set. Only one property must be set among these properties: sonstigeFuehrungsperson, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set sonstigeFuehrungsperson value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PositionSonstigeFuehrungspersonType $sonstigeFuehrungsperson
     * @return \StructType\PositionType
     */
    public function setSonstigeFuehrungsperson(\StructType\PositionSonstigeFuehrungspersonType $sonstigeFuehrungsperson = null)
    {
        // validation for constraint: choice(vorstand, aufsichtsrat, sonstigeFuehrungsperson, inEngerBeziehung)
        if ('' !== ($sonstigeFuehrungspersonChoiceErrorMessage = self::validateSonstigeFuehrungspersonForChoiceConstraintsFromSetSonstigeFuehrungsperson($sonstigeFuehrungsperson))) {
            throw new \InvalidArgumentException($sonstigeFuehrungspersonChoiceErrorMessage, __LINE__);
        }
        if (is_null($sonstigeFuehrungsperson) || (is_array($sonstigeFuehrungsperson) && empty($sonstigeFuehrungsperson))) {
            unset($this->sonstigeFuehrungsperson);
        } else {
            $this->sonstigeFuehrungsperson = $sonstigeFuehrungsperson;
        }
        return $this;
    }
    /**
     * Get inEngerBeziehung value
     * @return \StructType\PositionInEngerBeziehungType|null
     */
    public function getInEngerBeziehung()
    {
        return isset($this->inEngerBeziehung) ? $this->inEngerBeziehung : null;
    }
    /**
     * This method is responsible for validating the value passed to the setInEngerBeziehung method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInEngerBeziehung method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateInEngerBeziehungForChoiceConstraintsFromSetInEngerBeziehung($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'vorstand',
            'aufsichtsrat',
            'sonstigeFuehrungsperson',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property inEngerBeziehung can\'t be set as the property %s is already set. Only one property must be set among these properties: inEngerBeziehung, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set inEngerBeziehung value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PositionInEngerBeziehungType $inEngerBeziehung
     * @return \StructType\PositionType
     */
    public function setInEngerBeziehung(\StructType\PositionInEngerBeziehungType $inEngerBeziehung = null)
    {
        // validation for constraint: choice(vorstand, aufsichtsrat, sonstigeFuehrungsperson, inEngerBeziehung)
        if ('' !== ($inEngerBeziehungChoiceErrorMessage = self::validateInEngerBeziehungForChoiceConstraintsFromSetInEngerBeziehung($inEngerBeziehung))) {
            throw new \InvalidArgumentException($inEngerBeziehungChoiceErrorMessage, __LINE__);
        }
        if (is_null($inEngerBeziehung) || (is_array($inEngerBeziehung) && empty($inEngerBeziehung))) {
            unset($this->inEngerBeziehung);
        } else {
            $this->inEngerBeziehung = $inEngerBeziehung;
        }
        return $this;
    }
}
