<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for preisVolumenType StructType
 * @subpackage Structs
 */
class PreisVolumenType extends AbstractStructBase
{
    /**
     * The transaktion
     * Meta information extracted from the WSDL
     * - maxOccurs: 500
     * @var \StructType\TransaktionType[]
     */
    public $transaktion;
    /**
     * Constructor method for preisVolumenType
     * @uses PreisVolumenType::setTransaktion()
     * @param \StructType\TransaktionType[] $transaktion
     */
    public function __construct(array $transaktion = array())
    {
        $this
            ->setTransaktion($transaktion);
    }
    /**
     * Get transaktion value
     * @return \StructType\TransaktionType[]|null
     */
    public function getTransaktion()
    {
        return $this->transaktion;
    }
    /**
     * This method is responsible for validating the values passed to the setTransaktion method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTransaktion method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTransaktionForArrayConstraintsFromSetTransaktion(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $preisVolumenTypeTransaktionItem) {
            // validation for constraint: itemType
            if (!$preisVolumenTypeTransaktionItem instanceof \StructType\TransaktionType) {
                $invalidValues[] = is_object($preisVolumenTypeTransaktionItem) ? get_class($preisVolumenTypeTransaktionItem) : sprintf('%s(%s)', gettype($preisVolumenTypeTransaktionItem), var_export($preisVolumenTypeTransaktionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The transaktion property can only contain items of type \StructType\TransaktionType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set transaktion value
     * @throws \InvalidArgumentException
     * @param \StructType\TransaktionType[] $transaktion
     * @return \StructType\PreisVolumenType
     */
    public function setTransaktion(array $transaktion = array())
    {
        // validation for constraint: array
        if ('' !== ($transaktionArrayErrorMessage = self::validateTransaktionForArrayConstraintsFromSetTransaktion($transaktion))) {
            throw new \InvalidArgumentException($transaktionArrayErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(500)
        if (is_array($transaktion) && count($transaktion) > 500) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 500', count($transaktion)), __LINE__);
        }
        $this->transaktion = $transaktion;
        return $this;
    }
    /**
     * Add item to transaktion value
     * @throws \InvalidArgumentException
     * @param \StructType\TransaktionType $item
     * @return \StructType\PreisVolumenType
     */
    public function addToTransaktion(\StructType\TransaktionType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TransaktionType) {
            throw new \InvalidArgumentException(sprintf('The transaktion property can only contain items of type \StructType\TransaktionType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: maxOccurs(500)
        if (is_array($this->transaktion) && count($this->transaktion) >= 500) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 500', count($this->transaktion)), __LINE__);
        }
        $this->transaktion[] = $item;
        return $this;
    }
}
